; test ATmega8515 I/O
; all ports are counting in binary
.NOLIST
.INCLUDE "m8515def.inc"
.LIST
; All ports A,B,C,D,E are outputs
; A counter is output to all ports

.def	temp1 	= r16
.def	temp2 	= r17
.def	temp3 	= r18
.def	Td1		= r19
.def	Td2		= r20
.def	Td3		= r21
.def	poA		= r22
.def	poB		= r23
.def	cnt		= r24

; Code starts here
.CSEG
.ORG $0000

rjmp RESET			; Reset Handler

; **************** End of interrupt service routines ***********
sdel:	ser		temp1
		ser		temp2
sdel1:	dec		temp1
		brne	sdel1
		ser		temp1
		dec		temp2
		brne	sdel1
		ret
; ******************** Main program ********************************

RESET:	ldi 	r16, low(RAMEND)	; Main program start
		out 	SPL,r16 			; Set Stack Pointer to top of RAM
		ldi		r16,HIGH(RAMEND)
		out		SPH,r16

		ser		temp1
		out		ddrA,temp1
		out		ddrB,temp1
		out		ddrC,temp1
		out		ddrD,temp1
		out		ddrE,temp1

arxi:	ldi		cnt,1
arx1:	out		portA,cnt
		out		portB,cnt
		out		portC,cnt
		out		portD,cnt
		out		portE,cnt
		rcall	sdel
		inc		cnt
		rjmp	arx1

